<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="140px"
      v-loading="formLoading"
    >
      <el-form-item :label="t('EnergyManagement.EnergyType.dialogCodeLabel')" prop="code">
        <el-input
          v-model="formData.code"
          :placeholder="t('EnergyManagement.EnergyType.dialogCodePlaceholder')"
          :disabled="formType === 'update'"
        />
      </el-form-item>
      <el-form-item :label="t('EnergyManagement.EnergyType.dialogNameLabel')" prop="name">
        <el-input
          v-model="formData.name"
          :placeholder="t('EnergyManagement.EnergyType.dialogNamePlaceholder')"
        />
      </el-form-item>
      <el-form-item :label="t('EnergyManagement.EnergyType.dialogUnitLabel')" prop="unit">
        <el-input
          v-model="formData.unit"
          :placeholder="t('EnergyManagement.EnergyType.dialogUnitPlaceholder')"
        />
      </el-form-item>
      <el-form-item :label="t('EnergyManagement.EnergyType.dialogIsEnableLabel')" prop="isEnable">
            <el-radio-group v-model="formData.isEnable">
              <el-radio
                v-for="dict in getBoolDictOptions(DICT_TYPE.INFRA_BOOLEAN_STRING)"
                :key="dict.value"
                :label="dict.value"
              >
                {{ dict.label }}
              </el-radio>
            </el-radio-group>
      </el-form-item>
      <el-form-item :label="t('EnergyManagement.EnergyType.dialogRemarkLabel')" prop="remark">
        <el-input
          v-model="formData.remark"
          :placeholder="t('EnergyManagement.EnergyType.dialogRemarkPlaceholder')"
        />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">
        {{ t('EnergyManagement.EnergyType.dialogOkButtonText') }}
      </el-button>
      <el-button @click="dialogVisible = false">
        {{ t('EnergyManagement.EnergyType.dialogCancelButtonText') }}
      </el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
  import {DICT_TYPE, getBoolDictOptions} from '@/utils/dict'
import { EnergyTypeApi, EnergyTypeVO } from '@/api/mes/energytype'

/** 能耗类型 表单 */
defineOptions({ name: 'EnergyTypeForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  code: undefined,
  name: undefined,
  unit: undefined,
  isEnable: undefined,
  remark: undefined,
})
const formRules = reactive({
  code: [{ required: true, message: t('EnergyManagement.EnergyType.validatorCodeRequired'), trigger: 'blur' }],
  name: [{ required: true, message: t('EnergyManagement.EnergyType.validatorNameRequired'), trigger: 'blur' }],
  unit: [{ required: true, message: t('EnergyManagement.EnergyType.validatorUnitRequired'), trigger: 'blur' }],
  isEnable: [{ required: true, message: t('EnergyManagement.EnergyType.validatorIsEnableRequired'), trigger: 'blur' }],
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await EnergyTypeApi.getEnergyType(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as EnergyTypeVO
    if (formType.value === 'create') {
      await EnergyTypeApi.createEnergyType(data)
      message.success(t('common.createSuccess'))
    } else {
      await EnergyTypeApi.updateEnergyType(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    code: undefined,
    name: undefined,
    unit: undefined,
    isEnable: true,
    remark: undefined,
  }
  formRef.value?.resetFields()
}
</script>
